<template>
  <div>
    <el-card>
      <el-form :model="filterQuery" label-width="100px" size="mini">
        <el-row>
          <el-col :span="6">
            <el-form-item label="模板名称:" class="query-form-item">
              <el-input v-model="filterQuery.name" placeholder="请输入模板名称"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="模板编码:" class="query-form-item">
              <el-input v-model="filterQuery.code" placeholder="请输入模板编码"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item>
              <el-button-group>
                <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
                <el-button type="primary" icon="search" @click="handleAddClick">新增</el-button>
              </el-button-group>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <el-table v-loading="loading" :data="list" @current-change="handleDetail" border highlight-current-row
                style="width: 100%">
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="模板编码" prop="code" width="260"></el-table-column>
        <el-table-column label="模板名称" prop="name" width="260"></el-table-column>
        <el-table-column label="备注" prop="remark" width="260"></el-table-column>
        <el-table-column label="创建人" prop="createByName" width="260"></el-table-column>
        <el-table-column label="创建时间" prop="createTime" width="260"></el-table-column>
        <el-table-column label="操作" width="220">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="handleModifyClick(scope.row)">编辑</el-button>
            <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)">删除</el-button>
            <el-button type="text" size="small" @click.native.stop="selectDialog(scope.row)">选入产品</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="handleCurrentChange"
      ></pagination>
    </el-card>

    <el-card>
      <el-table v-loading="loading" :data="delectList" border highlight-current-row style="width: 100%">
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="产品DI" prop="nameCode" width="260"></el-table-column>
        <el-table-column label="产品编码" prop="thirdId" width="260"></el-table-column>
        <el-table-column label="产品名称" prop="cpmctymc" width="260"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh"></el-table-column>
        <el-table-column label="计量单位" prop="measname"></el-table-column>
        <el-table-column label="数量" prop="count"></el-table-column>
        <el-table-column label="生产企业" prop="ylqxzcrbarmc"></el-table-column>
        <el-table-column label="注册/备案号" prop="zczbhhzbapzbh"></el-table-column>
      </el-table>
      <pagination
        v-show="delectTotal>0"
        :total="delectTotal"
        :limit.sync="delectQuery.limit"
        :page.sync="delectQuery.page"
        @pagination="handleCurrentDelectChange"
      ></pagination>
    </el-card>

    <el-dialog
      :title="formMap[formName]"
      :visible.sync="formVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="40%"
      :before-close="closeDialog"
      v-if="formVisible"
    >
      <destinyModelEdit
        :editQuery="editQuery"
        :closeDialog="closeDialog"
      ></destinyModelEdit>
    </el-dialog>

    <el-dialog
      title="选入产品"
      :visible.sync="selectFormVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="80%"
      :before-close="closeDialog"
      v-if="selectFormVisible"
    >
      <destinyModelSelectProduct
        :editQuery="editQuery"
        :codeArray="codeArray"
        :closeDialog="closeDialog"
      ></destinyModelSelectProduct>
    </el-dialog>


  </div>
</template>

<script>
import {
  addModeldestiny,
  delectModeldestiny,
  filterDestinyDelect,
  getBasicDestinyfilter
} from "@/api/basic/basicDestinyRel";
import destinyModelEdit from "@/views/basic/destiny/destinyModelEdit";
import destinyModelSelectProduct from "@/views/basic/destiny/destinyModelSelectProduct";


export default {
  data() {
    return {
      filterQuery: {
        name: "",
        code: "",
        type: 2,
        page: 1,
        limit: 20
      },
      editType: "",
      formVisible: false,
      selectFormVisible: false,
      loading: false,
      formName: "",
      total: 0,
      list: [],
      codeArray: [],
      editQuery: {},
      formMap: {
        "add": "新增定数包模板",
        "edit": "编辑定数包模板"
      },
      delectQuery: {
        id: null,
        page: 1,
        limit: 20
      },
      delectList: [],
      delectTotal: 0,
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: ""
      });
      this.filterQuery = {
        name: "",
        code: "",
        type: 2,
        page: 1,
        limit: 20
      };
      this.getList();
    },
    onSubmit() {
      this.$router.push({
        path: "",
      });
      this.filterQuery.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      getBasicDestinyfilter(this.filterQuery).then(response => {
        this.loading = false;
        this.list = response.data.list || [];
        this.total = response.data.total || 0;
      }).catch(() => {
        this.loading = false;
        this.list = [];
        this.total = 0;
        this.roles = [];
      });
    },
    handleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getList();
    },
    handleCurrentDelectChange(val) {
      this.delectQuery.page = val.page;
      this.filterDestinyDelect()
    },
    handleAddClick() {
      this.formName = "add";
      this.formVisible = true;
    },
    handleModifyClick(row) {
      this.formName = "edit";
      this.formVisible = true;
      this.editQuery = row;
    },
    deleteDialog(row) {
      delectModeldestiny(row).then(res => {
        if (res.code == 20000) {
          this.getList();
        } else {
          this.$message.error(res.message);
        }
      }).catch(() => {
        this.$message.error("删除失败！");
      });
    },
    selectDialog(row) {
      this.selectFormVisible = true;
      this.editQuery = row;
    },
    closeDialog() {
      this.formVisible = false;
      this.selectFormVisible = false;
      this.getList();
      this.delectList = []
      this.editQuery = {}
    },
    handleDetail(row) {
      this.delectQuery.id = row.id
      this.filterDestinyDelect()
    },
    filterDestinyDelect() {
      filterDestinyDelect(this.delectQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.delectList = response.data.list || [];
            this.delectTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.delectList = [];
            this.delectTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.delectList = [];
          this.delectTotal = 0;
        });
    },
  }
  ,
  mounted() {
  }
  ,
  components: {
    destinyModelEdit, destinyModelSelectProduct
  }
  ,
  created() {
    this.getList();
  }
}
;
</script>
